--- old/usr/src/lib/libdtrace/common/dt_provider.c	2013-08-15 23:06:19.745727140 -0400
+++ new/usr/src/lib/libdtrace/common/dt_provider.c	2013-08-15 23:06:19.771096361 -0400
@@ -24,8 +24,6 @@
  * Use is subject to license terms.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sys/types.h>
 #include <sys/sysmacros.h>
 
@@ -360,6 +358,18 @@
 	if (dtrace_str2desc(dtp, DTRACE_PROBESPEC_NAME, s, &pd) != 0)
 		return (NULL); /* dt_errno is set for us */
 
+	/*
+	 * Make sure the probe is fully specified as being in this provider,
+	 * even if the name is missing that part of the specification,
+	 * otherwise our lookups may match in the wrong provider when we ask
+	 * dtrace(7D).
+	 *
+	 * We always do this because we are explicitly searching _this_
+	 * provider.
+	 */
+	bcopy(pvp->pv_desc.dtvd_name, pd.dtpd_provider,
+	    DTRACE_PROVNAMELEN);
+
 	keylen = dt_probe_keylen(&pd);
 	key = dt_probe_key(&pd, alloca(keylen));
 
